varying vec2 vUv;
uniform float uTime;
uniform sampler2D uTexture;

uniform vec3 uBGColor;
uniform vec3 uFGColor;

void main() {
    float speed = 0.2; // speed of the animation -- higher is faster
    float time = uTime * speed; // increment time

    vec2 uv = vUv;  // get the uv coordinates

    // uv = fract(uv * repeat); // repeat the texture
    vec2 repeat = vec2(7.0, 9.0); // repeat the texture this many times

    uv.x += cos(uv.y);  // X offset is sin(y) or cos(y) to skew the texture
    // uv.x += sin(uv.y + time) * 0.25;  // X offset is sin(y) or cos(y) to skew the texture, wiggle with time

    // uv = fract(uv * repeat + (0.0, time)); // repeat the texture and move it over time on Y axis
    uv = fract(uv * repeat + (0.0, time * 0.5)); // repeat the texture and move it over time on Y axis

    vec4 color = texture2D(uTexture, uv);   // get the color from where we are in the text texture

    // If color is alpha, make it uBGColor
    if (color.a < 0.5) {
        color = vec4(uBGColor, 1.0);
    } else {
        // Otherwise, make it uFGColor
        color = vec4(uFGColor, 1.0);

        // // Add some noise to the color
        color.r += sin(uv.x * 10.0 + time) * 0.05;
        color.g += cos(uv.x * 10.0 + time) * 0.05;
        color.b += sin(uv.x * 10.0 + time) * 0.05;
    }

    
    gl_FragColor = color;   // set the color
}